#!/usr/local/bin/lua

local function processInput(...)
	local sessions = {}
	local firstStamp
	for line in ... do
		local timestamp, phase
		timestamp, line = line:match('([^=]+)%= (.*)')
		local tt = {}
		tt.year, tt.month, tt.day, tt.hour, tt.min, tt.sec = timestamp:match("(%d%d%d%d)(%d%d)(%d%d)_(%d%d)(%d%d)(%d%d)")
		if not firstStamp then firstStamp = os.time(tt) end
		phase, line = line:match('%`([%<%>])(.*)')
		if phase then
			if phase == '<' then line = '-' .. line end
			table.insert(sessions, {time=os.difftime(os.time(tt), firstStamp); amount=tonumber(line)})
		end
	end
	return sessions
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	for _, order in ipairs(t) do
		io.write(ID, ',', order.time, ',', order.amount, '\n')
	end
end

local function outputAverage(file, t)
	print(file)
	local totalDealt, totalReceived = 0, 0
	for _, value in ipairs(t) do
		if value.amount > 0 then
			totalDealt = totalDealt + value.amount
		else
			totalReceived = totalReceived - value.amount
		end
	end
	print("Average damage ratio:", totalDealt / totalReceived)
	print("Damage dealt/received per second", t[#t].time / totalDealt, t[#t].time / totalReceived)
end

require "parse_files" (processInput, outputCSV, ...)
