#!/usr/local/bin/lua
local function radius(x, y)
	return math.sqrt(x * x + y * y)
end
local function pythagorean(a, b)
	return radius(a.x - b.x, a.y - b.y)
end

local function processInput(...)
	local sessions = {}
	local position = {}
	local menuBegan
	for line in ... do
		local timestamp, phase
		timestamp, phase, line = line:match('([%d_]+)%= %@(.)(.*)')
		if timestamp then
			local tt = {}
			tt.year, tt.month, tt.day, tt.hour, tt.min, tt.sec = timestamp:match("(%d%d%d%d)(%d%d)(%d%d)_(%d%d)(%d%d)(%d%d)")
			if phase == '^' then
				menuBegan = os.time(tt)
			elseif phase == '$' and menuBegan then
				table.insert(sessions, os.difftime(os.time(tt), menuBegan))
				menuBegan = nil
			end
		end
	end
	return sessions
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	for _, value in ipairs(t) do
		io.write(ID, ',', value, '\n')
	end
end

local function outputAverage(file, t)
	print(file)
	local total = 0
	for _, distance in ipairs(t) do
		total = total + distance
	end
	print("Average Menu Suspension Time:", total / #t)
end

require "parse_files" (processInput, outputCSV, ...)
