#!/usr/local/bin/lua

local function processInput(...)
	local sessions = {}
	local cancelCount, completeCount = 0, 0
	for line in ... do
		local action, phase
		phase, line = line:match('%#(.)(.*)')
		if phase and line:match("%(Unit%)$") then
			if not line:match("defend") then
				if phase == '-' then
					cancelCount = cancelCount + 1
				elseif phase == '$' then
					completeCount = completeCount + 1
				end
			end
		end
	end
	return {cancelled = cancelCount, completed = completeCount}
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	io.write(ID, ',', t.completed, ',', t.cancelled, '\n')
end

local function outputAverage(file, t)
	print(file)
	print("Order Completion Ratio:", t.completed / t.cancelled)
end

require "parse_files" (processInput, outputCSV, ...)
