#!/usr/local/bin/lua

local function processInput(...)
	local sessions = {}
	local lastStamp
	for line in ... do
		local timestamp, phase
		timestamp, phase, line = line:match('([^=]+)%= %#(.)(.*)')
		if phase and line:match("%(Unit%)$") then
			if phase == '^' and not line:match("defend") then
				if timestamp ~= lastStamp then
					table.insert(sessions, 1)
					lastStamp = timestamp
				else
					local i = #sessions
					sessions[i] = sessions[i] + 1
				end
			end
		end
	end
	return sessions
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	for _, order in ipairs(t) do
		io.write(ID, ',', order, '\n')
	end
end

local function outputAverage(file, t)
	print(file)
	local total = 0
	for _, value in ipairs(t) do
		total = total + value
	end
	print("Average units per order:", total / #t)
end

require "parse_files" (processInput, outputCSV, ...)
