#!/usr/local/bin/lua

local function processInput(...)
	local sessions = {}
	local outstanding = {}
	local firstStamp
	for line in ... do
		local timestamp, phase
		timestamp, line = line:match('([^=]+)%= (.*)')
		local tt = {}
		tt.year, tt.month, tt.day, tt.hour, tt.min, tt.sec = timestamp:match("(%d%d%d%d)(%d%d)(%d%d)_(%d%d)(%d%d)(%d%d)")
		if not firstStamp then firstStamp = os.time(tt) end
		phase, line = line:match('%#([-^$])(.*)')
		if phase and line:match("%(Unit%)$") then
			local order = line:match("^%w+")
			if order ~= "defend" then
				if phase == '^' then
					outstanding[order] = outstanding[order] or {}
					table.insert(outstanding[order], os.time(tt))
				else
					if outstanding[order] then
						table.insert(sessions, {time = os.difftime(os.time(tt), table.remove(outstanding[order], 1) or os.time(tt)), action = phase})
					end
				end
			end
		end
	end
	return sessions
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	for _, order in ipairs(t) do
		io.write(ID, ',', order.time, ',', order.action, '\n')
	end
end

local function outputAverage(file, t)
	print(file)
	local total = 0
	for _, value in ipairs(t) do
		total = total + value
	end
	print("Average order length:", total / #t)
end

require "parse_files" (processInput, outputCSV, ...)
