#!/usr/local/bin/lua

local function processInput(...)
	local sessions = {}
	local firstStamp
	for line in ... do
		local timestamp, phase
		timestamp, line = line:match('([^=]+)%= (.*)')
		local tt = {}
		tt.year, tt.month, tt.day, tt.hour, tt.min, tt.sec = timestamp:match("(%d%d%d%d)(%d%d)(%d%d)_(%d%d)(%d%d)(%d%d)")
		if not firstStamp then firstStamp = os.time(tt) end
		phase, line = line:match('%#(.)(.*)')
		if phase and line:match("%(Unit%)$") then
			if phase == '^' and not line:match("defend") then
				table.insert(sessions, {time=os.difftime(os.time(tt), firstStamp); order=line:match("^[^%(]+")})
			end
		end
	end
	return sessions
end

local function outputCSV(file, t)
	local ID = file:match("([^/.]+).log")
	for _, order in ipairs(t) do
		io.write(ID, ',', order.time, ',', order.order, '\n')
	end
end

local function outputAverage(file, t)
	print(file)
	print("Average orders per second:", t[#t].time / #t)
end

require "parse_files" (processInput, outputCSV, ...)
